From fef3ff2cfe6d1826c8093dfb6807556d8f2e4acc Mon Sep 17 00:00:00 2001
From: =?utf-8?q?S=C3=A9bastien=20Escudier?= <sebastien-devel@celeos.eu>
Date: Wed, 3 Dec 2008 10:13:09 +0100
Subject: [PATCH] Try to fix a deadlock between vlm and media list

---
 modules/misc/rtsp.c |   20 ++++++++++++++------
 1 files changed, 14 insertions(+), 6 deletions(-)

diff --git a/modules/misc/rtsp.c b/modules/misc/rtsp.c
index 5583c64..1631e7f 100644
--- a/modules/misc/rtsp.c
+++ b/modules/misc/rtsp.c
@@ -433,10 +433,6 @@ static vod_media_t *MediaNew( vod_t *p_vod, const char *psz_name,
 
     p_media->p_vod = p_vod;
 
-    vlc_mutex_lock( &p_sys->lock_media );
-    TAB_APPEND( p_sys->i_media, p_sys->media, p_media );
-    vlc_mutex_unlock( &p_sys->lock_media );
-
     vlc_mutex_init( &p_media->lock );
     p_media->psz_session_name = strdup("");
     p_media->psz_session_description = strdup("");
@@ -460,6 +456,10 @@ static vod_media_t *MediaNew( vod_t *p_vod, const char *psz_name,
     }
     vlc_mutex_unlock( &p_item->lock );
 
+    vlc_mutex_lock( &p_sys->lock_media );
+    TAB_APPEND( p_sys->i_media, p_sys->media, p_media );
+    vlc_mutex_unlock( &p_sys->lock_media );
+
     return p_media;
 }
 
@@ -470,7 +470,9 @@ static void MediaDel( vod_t *p_vod, vod_media_t *p_media )
     msg_Dbg( p_vod, "deleting media: %s", p_media->psz_rtsp_path );
 
     vlc_mutex_lock( &p_sys->lock_media );
+    vlc_mutex_lock( &p_media->lock );
     TAB_REMOVE( p_sys->i_media, p_sys->media, p_media );
+    vlc_mutex_unlock( &p_media->lock );
     vlc_mutex_unlock( &p_sys->lock_media );
 
     while( p_media->i_rtsp > 0 )
@@ -844,8 +846,14 @@ static void* CommandThread( vlc_object_t *p_this )
                 break;
         }
         if( i >= p_sys->i_media )
-            goto next;
+        {
+            vlc_mutex_unlock( &p_sys->lock_media );
+            goto next;        	
+        }
+
         p_media = p_sys->media[i];
+        vlc_mutex_lock ( &p_media->lock );
+        vlc_mutex_unlock( &p_sys->lock_media );
 
         switch( cmd.i_type )
         {
@@ -880,9 +888,9 @@ static void* CommandThread( vlc_object_t *p_this )
         default:
             break;
         }
+        vlc_mutex_unlock ( &p_media->lock );
 
     next:
-        vlc_mutex_unlock( &p_sys->lock_media );
         free( cmd.psz_session );
         free( cmd.psz_arg );
     }
-- 
1.5.4.3

